' Cloudy's config file updater
' This VBScript code will run in Windows 98, 2000 and XP
' It will update a config file entered as 1st argument including the full path
' The updates should be in an updater file entered as 2nd argument including the full path
' The updater file should include section headers for all statements
' The order of the sections in the updater file is irrelevant
' The order of the statements within each section is also irrelevant
' The program scans the config file, keeping track of the section. For each line it checks whether it is a config statement, ignoring other types of lines or remmed-out statements.  Once checked that it is a config statement, it reads the whole updater file looking for a matching section and statement. Whenever a match is found, the config statement is updated. The updated file is stored as C:\Config.cfg . Once the process is completed, C:\config.cfg is copied into the original config file.
'
Dim arof, aror, aruf, arup, carr, car2, eqpo, eqpu, fior, fiup, fin, fine, fso, leup, linu, lior, liup, _ 
paor, paup, remo, seor, seup, valu, wss, disp
Set wss = WScript.CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")
carr = Chr(13) & Chr(10) : car2 = carr & carr
' 19              			Arguments: full path and name of file to be updated and of updater file
set args = WScript.Arguments
paor = args.Item(0)
paup = args.Item(1)
If paor = "" or paup = "" Then
	msgbox "Path is blank" & carr & carr & "Procedure aborted"
	WScript.Quit
	end if
' 27 					Now process each line in the config file
Set fior = fso.OpenTextFile(paor,1)
Set fine = fso.CreateTextFile("C:\Config.cfg", True)
seor = ""
Do While Not fior.AtEndOfStream		
    lior = fior.ReadLine
    If Left(lior,1) = "[" then seor = Trim(lior)	' if new sector, update original sector
'							' find initial remouts and equal sign
    remo = Left(lior,2)
    eqpo = InStr(lior,"=")	
    If remo <> "//" and eqpo > 0 then
' 					Argument line found in config file: look for update
	arof = Left(lior,eqpo-1)			' full argument
	aror = Trim(arof)				' argument without leading or trailing blanks
'		msgbox lior & carr & aror	
	Set fiup = fso.OpenTextFile(paup,1)
' 
	seup = ""	
	Do While Not fiup.AtEndOfStream			' loop through all the updater file
  	    liup = fiup.ReadLine
	    If Left(liup,1) = "[" then seup = Trim(liup) ' if new section, update updater section
	    eqpu = InStr(liup,"=")
	    If eqpu > 0 then
' 					Argument line found in updater: look for match
		aruf = Left(liup,eqpu-1)
		arup = Trim (aruf)
		If  seor = seup and aror = arup then	' if match found, update original line
		    leup = Len(liup)
		    valu = Right(liup,leup-eqpu)		    	
		    linu = arof & "=" & valu		
		    lior = linu
		    end if
		end if
	    Loop
	fiup.Close
	end if
'
    fine.WriteLine lior
    Loop
'
fior.Close
fine.Close
Set fin = fso.GetFile("C:\Config.cfg")
fin.Copy(paor)
fso.DeleteFile("C:\Config.cfg")
'					Prepare listing of updater file
Set fiup = fso.OpenTextFile(paup,1)
disp = ""
Do While Not fiup.AtEndOfStream
    liup = fiup.ReadLine
    If Left(liup,2) <> "//" then disp = disp & liup & carr
    Loop
fiup.Close
msgbox disp & carr & "File successfully updated",, "Updating a config file"
'---end of script---
